/*
* VIOCLR.H - General color definitions for vio-programs.
*
*
* PROGRAMMER:	    Martti Ylikoski
* CREATED:	    6.11.1991
* VERSION:	    1.0
*
*/

/* VIO definitions */

#define BLACK	      64
#define DARK_GREY     56
#define LIGHT_GREY    7
#define RED	      4
#define DARK_RED      32
#define LIGHT_RED     36
#define GREEN	      2
#define DARK_GREEN    16
#define LIGHT_GREEN   18
#define YELLOW	      54
#define DARK_YELLOW   20
#define LIGHT_YELLOW  62
#define BLUE	      1
#define DARK_BLUE     8
#define LIGHT_BLUE    11
#define MAGENTA       5
#define DARK_MAGENTA  40
#define LIGHT_MAGENTA 21
#define CYAN	      35
#define DARK_CYAN     49
#define LIGHT_CYAN    27
#define WHITE	      63

#define ESC 27

typedef struct {
   char color[20] ;
   USHORT cint ;
} TABLE_ENTRY ;

TABLE_ENTRY colors[22] = {
    "BLACK", BLACK,
    "LIGHT_GREY", LIGHT_GREY,
    "DARK_GREY", DARK_GREY,
    "RED", RED,
    "LIGHT_RED", LIGHT_RED,
    "DARK_RED", DARK_RED,
    "GREEN", GREEN,
    "LIGHT_GREEN", LIGHT_GREEN,
    "DARK_GREEN", DARK_GREEN,
    "YELLOW", YELLOW,
    "LIGHT_YELLOW", LIGHT_YELLOW,
    "DARK_YELLOW", DARK_YELLOW,
    "BLUE", BLUE,
    "LIGHT_BLUE", LIGHT_BLUE,
    "DARK_BLUE", DARK_BLUE,
    "MAGENTA", MAGENTA,
    "LIGHT_MAGENTA", LIGHT_MAGENTA,
    "DARK_MAGENTA", DARK_MAGENTA,
    "CYAN", CYAN,
    "LIGHT_CYAN", LIGHT_CYAN,
    "DARK_CYAN", DARK_CYAN,
    "WHITE", WHITE
} ;


/* ANSI definitions begin */

#define FBLACK	  30
#define FRED	  31
#define FGREEN	  32
#define FYELLOW   33
#define FBLUE	  34
#define FMAGENTA  35
#define FCYAN	  36
#define FWHITE	  37

#define BBLACK	  40
#define BRED	  41
#define BGREEN	  42
#define BYELLOW   43
#define BBLUE	  44
#define BMAGENTA  45
#define BCYAN	  46
#define BWHITE	  47

typedef struct {
   char color[20] ;
   int fint ;
   int bint ;
} ANSI_TABLE_ENTRY ;

ANSI_TABLE_ENTRY ansi_colors[23] = {
    "BLACK", FBLACK, BBLACK,
    "LIGHT_GREY", FWHITE, BWHITE,
    "DARK_GREY", FBLACK, BBLACK,
    "RED", FRED, BRED,
    "LIGHT_RED", FRED, BRED,
    "DARK_RED", FRED, BRED,
    "GREEN", FGREEN, BGREEN,
    "LIGHT_GREEN", FGREEN, BGREEN,
    "DARK_GREEN", FGREEN, BGREEN,
    "YELLOW", FYELLOW,	BYELLOW,
    "LIGHT_YELLOW", FYELLOW,  BYELLOW,
    "DARK_YELLOW", FYELLOW, BYELLOW,
    "BLUE", FBLUE,  BBLUE,
    "LIGHT_BLUE", FBLUE, BBLUE,
    "DARK_BLUE", FBLUE, BBLUE,
    "MAGENTA", FMAGENTA, BMAGENTA,
    "LIGHT_MAGENTA", FMAGENTA, BMAGENTA,
    "DARK_MAGENTA", FMAGENTA, BMAGENTA,
    "CYAN", FCYAN, BCYAN,
    "LIGHT_CYAN", FCYAN, BCYAN,
    "DARK_CYAN", FCYAN, BCYAN,
    "WHITE", FWHITE, BWHITE,
    "DEFAULT", FWHITE, BBLACK  /* default white on black */
} ;

//ANSI_TABLE_ENTRY colors[10] = {
//    "BLACK", FBLACK, BBLACK,
//    "RED", FRED, BRED,
//    "GREEN", FGREEN, BGREEN,
//    "YELLOW", FYELLOW, BYELLOW,
//    "BLUE", FBLUE, BBLUE,
//    "MAGENTA", FMAGENTA, BMAGENTA,
//    "CYAN", FCYAN, BCYAN,
//    "WHITE", FWHITE, BWHITE,
//    "DEFAULT", FWHITE, BBLACK	/* default white on black */
//} ;
